searchNodes=[{"ref":"UUIDTools.html","title":"UUIDTools","type":"module","doc":"Documentation for UUIDTools."},{"ref":"UUIDTools.html#binary_to_string!/2","title":"UUIDTools.binary_to_string!/2","type":"function","doc":"See UUIDTools.UUID.binary_to_string!/2."},{"ref":"UUIDTools.html#string_to_binary!/1","title":"UUIDTools.string_to_binary!/1","type":"function","doc":"See UUIDTools.UUID.string_to_binary!/1."},{"ref":"UUIDTools.html#uuid1/0","title":"UUIDTools.uuid1/0","type":"function","doc":"See UUIDTools.UUID.uuid1/0."},{"ref":"UUIDTools.html#uuid1/1","title":"UUIDTools.uuid1/1","type":"function","doc":"See UUIDTools.UUID.uuid1/1."},{"ref":"UUIDTools.html#uuid3/2","title":"UUIDTools.uuid3/2","type":"function","doc":"See UUIDTools.UUID.uuid3/2."},{"ref":"UUIDTools.html#uuid3/3","title":"UUIDTools.uuid3/3","type":"function","doc":"See UUIDTools.UUID.uuid3/3."},{"ref":"UUIDTools.html#uuid4/0","title":"UUIDTools.uuid4/0","type":"function","doc":"See UUIDTools.UUID.uuid4/0."},{"ref":"UUIDTools.html#uuid4/1","title":"UUIDTools.uuid4/1","type":"function","doc":"See UUIDTools.UUID.uuid4/1."},{"ref":"UUIDTools.html#uuid5/2","title":"UUIDTools.uuid5/2","type":"function","doc":"See UUIDTools.UUID.uuid5/2."},{"ref":"UUIDTools.html#uuid5/3","title":"UUIDTools.uuid5/3","type":"function","doc":"See UUIDTools.UUID.uuid5/3."},{"ref":"UUIDTools.UUID.html","title":"UUIDTools.UUID","type":"module","doc":"UUIDTools.UUID is a module that handles the generation of UUIDs for Elixir. It follows the RFC 4122."},{"ref":"UUIDTools.UUID.html#binary_to_string!/2","title":"UUIDTools.UUID.binary_to_string!/2","type":"function","doc":"Convert binary UUID data to a string. Will raise an ArgumentError if the given binary is not valid UUID data, or the format argument is not one of: :default, :hex, :urn, or :raw. Examples iex&gt; UUIDTools.UUID.binary_to_string!(&lt;&lt;135, 13, 248, 232, 49, 7, 68, 135, ...&gt; 131, 22, 129, 224, 137, 184, 194, 207&gt;&gt;) &quot;870df8e8-3107-4487-8316-81e089b8c2cf&quot; iex&gt; UUIDTools.UUID.binary_to_string!(&lt;&lt;142, 161, 81, 61, 248, 161, 77, 234, 155, ...&gt; 234, 107, 143, 75, 91, 110, 115&gt;&gt;, :hex) &quot;8ea1513df8a14dea9bea6b8f4b5b6e73&quot; iex&gt; UUIDTools.UUID.binary_to_string!(&lt;&lt;239, 27, 26, 40, 238, 52, 17, 227, 136, ...&gt; 19, 20, 16, 159, 241, 163, 4&gt;&gt;, :urn) &quot;urn:uuid:ef1b1a28-ee34-11e3-8813-14109ff1a304&quot; iex&gt; UUIDTools.UUID.binary_to_string!(&lt;&lt;39, 73, 196, 181, 29, 90, 74, 96, 157, ...&gt; 47, 171, 144, 84, 164, 155, 52&gt;&gt;, :raw) &lt;&lt;39, 73, 196, 181, 29, 90, 74, 96, 157, 47, 171, 144, 84, 164, 155, 52&gt;&gt;"},{"ref":"UUIDTools.UUID.html#string_to_binary!/1","title":"UUIDTools.UUID.string_to_binary!/1","type":"function","doc":"Convert a UUID string to its binary data equivalent. Will raise an ArgumentError if the given string is not a UUID representation in a format like: &quot;870df8e8-3107-4487-8316-81e089b8c2cf&quot; &quot;8ea1513df8a14dea9bea6b8f4b5b6e73&quot; &quot;urn:uuid:ef1b1a28-ee34-11e3-8813-14109ff1a304&quot; Examples iex&gt; UUIDTools.UUID.string_to_binary!(&quot;870df8e8-3107-4487-8316-81e089b8c2cf&quot;) &lt;&lt;135, 13, 248, 232, 49, 7, 68, 135, 131, 22, 129, 224, 137, 184, 194, 207&gt;&gt; iex&gt; UUIDTools.UUID.string_to_binary!(&quot;8ea1513df8a14dea9bea6b8f4b5b6e73&quot;) &lt;&lt;142, 161, 81, 61, 248, 161, 77, 234, 155, 234, 107, 143, 75, 91, 110, 115&gt;&gt; iex&gt; UUIDTools.UUID.string_to_binary!(&quot;urn:uuid:ef1b1a28-ee34-11e3-8813-14109ff1a304&quot;) &lt;&lt;239, 27, 26, 40, 238, 52, 17, 227, 136, 19, 20, 16, 159, 241, 163, 4&gt;&gt; iex&gt; UUIDTools.UUID.string_to_binary!(&lt;&lt;39, 73, 196, 181, 29, 90, 74, 96, 157, 47, ...&gt; 171, 144, 84, 164, 155, 52&gt;&gt;) &lt;&lt;39, 73, 196, 181, 29, 90, 74, 96, 157, 47, 171, 144, 84, 164, 155, 52&gt;&gt;"},{"ref":"UUIDTools.UUID.html#uuid1/1","title":"UUIDTools.UUID.uuid1/1","type":"function","doc":"Generate a new UUID v1. This version uses a combination of one or more of: unix epoch, random bytes, pid hash, and hardware address. Examples iex&gt; UUIDTools.UUID.uuid1() &quot;cdfdaf44-ee35-11e3-846b-14109ff1a304&quot; iex&gt; UUIDTools.UUID.uuid1(:default) &quot;cdfdaf44-ee35-11e3-846b-14109ff1a304&quot; iex&gt; UUIDTools.UUID.uuid1(:hex) &quot;cdfdaf44ee3511e3846b14109ff1a304&quot; iex&gt; UUIDTools.UUID.uuid1(:urn) &quot;urn:uuid:cdfdaf44-ee35-11e3-846b-14109ff1a304&quot; iex&gt; UUIDTools.UUID.uuid1(:raw) &lt;&lt;205, 253, 175, 68, 238, 53, 17, 227, 132, 107, 20, 16, 159, 241, 163, 4&gt;&gt; iex&gt; UUIDTools.UUID.uuid1(:slug) &quot;zf2vRO41EeOEaxQQn_GjBA&quot;"},{"ref":"UUIDTools.UUID.html#uuid1/3","title":"UUIDTools.UUID.uuid1/3","type":"function","doc":"Generate a new UUID v1, with an existing clock sequence and node address. This version uses a combination of one or more of: unix epoch, random bytes, pid hash, and hardware address. Examples iex&gt; UUIDTools.uuid1() &quot;e93880b4-c4b7-11e9-8925-f2189835db58&quot; iex&gt; UUIDTools.uuid1(:default) &quot;f580ace8-c4b7-11e9-a704-f2189835db58&quot; iex&gt; UUIDTools.uuid1(:hex) &quot;05bcb75ac4b811e99c8af2189835db58&quot; iex&gt; UUIDTools.uuid1(:urn) &quot;urn:uuid:10ac6930-c4b8-11e9-93d7-f2189835db58&quot; iex&gt; UUIDTools.uuid1(:raw) &lt;&lt;31, 88, 207, 250, 196, 184, 17, 233, 187, 65, 242, 24, 152, 53, 219, 88&gt;&gt; iex&gt; UUIDTools.uuid1(:slug) &quot;V7E_wsS4EemLq_IYmDXbWA&quot;"},{"ref":"UUIDTools.UUID.html#uuid3/3","title":"UUIDTools.UUID.uuid3/3","type":"function","doc":"Generate a new UUID v3. This version uses an MD5 hash of fixed value (chosen based on a namespace atom - see Appendix C of RFC 4122 and a name value. Can also be given an existing UUID String instead of a namespace atom. Examples iex&gt; UUIDTools.uuid3(:md5, &quot;google.com&quot;, :raw) &lt;&lt;154, 116, 200, 62, 44, 9, 53, 19, 167, 75, 145, 214, 121, 190, 130, 184&gt;&gt; iex&gt; UUIDTools.uuid3(&quot;8808f33a-3e11-3708-919e-15fba88908db&quot;, &quot;google.com&quot;) &quot;9556d661-520d-3843-8745-4e0601b06ca0&quot; iex&gt; UUIDTools.uuid3(:md5, &quot;google.com&quot;, :slug) &quot;mnTIPiwJNROnS5HWeb6CuA&quot;"},{"ref":"UUIDTools.UUID.html#uuid4/0","title":"UUIDTools.UUID.uuid4/0","type":"function","doc":"Generate a new UUID v4. This version uses pseudo-random bytes generated by the crypto module. Examples iex&gt; UUIDTools.uuid4() &quot;e453a6bf-1acc-41a0-a768-8e486ff0bc74&quot; iex&gt; UUIDTools.uuid4(:default) &quot;06e04ae3-5db2-4b20-bb31-fc1ffdc4ac87&quot; iex&gt; UUIDTools.uuid4(:hex) 98c73069ce8549ac82ef4a131d7f05b4 iex&gt; UUIDTools.uuid4(:urn) &quot;urn:uuid:18f2ea3b-6508-4f42-b65d-a0eaa6892bf4&quot; iex&gt; UUIDTools.uuid4(:raw) &lt;&lt;193, 103, 191, 223, 115, 251, 75, 179, 165, 138, 217, 109, 228, 155, 201, 163&gt;&gt; iex&gt; UUIDTools.uuid4(:slug) &quot;p78u0Qi7RpqX6D3A8FD5BQ&quot;"},{"ref":"UUIDTools.UUID.html#uuid4/1","title":"UUIDTools.UUID.uuid4/1","type":"function","doc":""},{"ref":"UUIDTools.UUID.html#uuid5/3","title":"UUIDTools.UUID.uuid5/3","type":"function","doc":"Generate a new UUID v5. This version uses an SHA1 hash of fixed value (chosen based on a namespace atom - see Appendix C of RFC 4122 and a name value. Can also be given an existing UUID String instead of a namespace atom. Examples iex&gt; UUIDTools.uuid5(:sha1, &quot;google.com&quot;) &quot;64ee70a4-8cc1-5d25-abf2-dea6c79a09c8&quot; iex&gt; UUIDTools.uuid5(&quot;d26d4db3-2a94-5185-a091-5b7b61148c87&quot;, &quot;google.com&quot;) &quot;4699746d-3d64-5122-a1f3-187f40fb63ac&quot; iex&gt; UUIDTools.uuid5(&quot;d26d4db3-2a94-5185-a091-5b7b61148c87&quot;, &quot;google.com&quot;, :slug) &quot;Rpl0bT1kUSKh8xh_QPtjrA&quot;"},{"ref":"readme.html","title":"Elixir UUIDTools","type":"extras","doc":"Elixir UUIDTools UUIDTools is a UUID generator and utilities for Elixir. See RFC 4122. Installation Releases are published through hex.pm. Add as a dependency in your mix.exs file: defp deps do [ { :uuid_tools, &quot;~&gt; 0.1.0&quot; } ] end Why we need another UUID library? I am of the idea that we need a UUID set of tools for our Elixir projects that is fast and complete (that is the reason for the name). Even if now the library does not seem different than UUID or other erlang versions of it, the direction is to create a swiss knife of unique id generation in our Elixir projects that is fast, complete and relaiable. Benchmark UUIDTools vs elixir_uuid Benchmark suite executing with the following configuration: warmup: 2 s time: 10 s memory time: 1 s parallel: 1 inputs: none specified Estimated total run time: 26 s Benchmarking UUID.uuid4/0... Benchmarking UUIDTools.uuid4/0... Name ips average deviation median 99th % UUIDTools.uuid4/0 483.88 K 2.07 μs ±1416.15% 2 μs 3 μs UUID.uuid4/0 326.39 K 3.06 μs ±832.57% 3 μs 4 μs Comparison: UUIDTools.uuid4/0 483.88 K UUID.uuid4/0 326.39 K - 1.48x slower +1.00 μs Memory usage statistics: Name average deviation median 99th % UUIDTools.uuid4/0 0.27 KB ±1.91% 0.27 KB 0.27 KB UUID.uuid4/0 1.58 KB ±0.33% 1.58 KB 1.58 KB Comparison: UUIDTools.uuid4/0 0.27 KB UUID.uuid4/0 1.58 KB - 5.81x memory usage +1.30 KB Copyright 2018-2019 Lorenzo Sinisi Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. UUID v1 Generated using a combination of time since the west adopted the gregorian calendar and the node id MAC address. iex&gt; UUIDTools.uuid1() &quot;d2bd2f04-c4c8-11e9-8be2-f2189835db58&quot; UUID v3 Generated using the MD5 hash of a name and either a namespace atom or an existing UUID. Valid namespace is :md5, nil or a binary iex&gt; UUIDTools.uuid3(:md5, &quot;google.com&quot;) &quot;fe4b24a0-9a38-3b32-84ca-ae0935462bc9&quot; iex&gt; UUIDTools.uuid3(&quot;fe4b24a0-9a38-3b32-84ca-ae0935462bc9&quot;, &quot;google.com&quot;) &quot;989a7ead-314e-31a1-9bb4-65033b275a99&quot; UUID v4 Generated based on pseudo-random bytes. iex&gt; UUIDTools.uuid4() &quot;3a569a7c-4d11-453f-82d8-f4fd328b2da0&quot; UUID v5 Generated using the SHA1 hash of a name and either :sha1 atom or an existing UUID. iex&gt; UUIDTools.uuid5(:sha1, &quot;google.com&quot;) &quot;951fc05f-a587-5487-8201-edbf02bcb563&quot; iex&gt; UUID.uuid5(&quot;951fc05f-a587-5487-8201-edbf02bcb563&quot;, &quot;google.com&quot;) &quot;8a72bb90-08a6-584b-89c1-5416e4173cf9&quot; Attribution Some code ported from avtobiff/erlang-uuid. Most code ported from zyro/elixir-uuid. License Copyright 2018-2019 Lorenzo Sinisi Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License."}]